import { DependencyInfo } from '../Lifetime';
import { Key, LifetimeCollection, Selector } from '../ServiceCollection';
import { IServiceProvider } from './IServiceProvider';
export declare type ProviderScope = Record<Key<any>, any>;
export declare class ScopedContext<E = any> implements IServiceProvider<E> {
    private readonly singletons;
    private readonly lookup;
    private readonly ordered;
    readonly lifetimes: LifetimeCollection<E>;
    readonly proxy: E;
    readonly scope: ProviderScope;
    constructor(parent: IServiceProvider<E>);
    get depth(): number;
    get lastSingleton(): DependencyInfo<E> | undefined;
    provide<T>(selector: Selector<T, E>): T;
    enter<T>(lifetime: DependencyInfo[], action: (context: ScopedContext<E>) => T): T;
    enterOnce<T>(lifetime: DependencyInfo, action: (context: ScopedContext<E>) => T): T;
    private _enter;
    private _leave;
    private getLifetime;
}
